' Dump Vectrex memory

call SetFrameRate(45)

notice = { _
    {-70, 70, "USE THIS PROGRAM FROM"}, _
    {-70, 50, "THE TERMINAL EMULATOR"}, _
    {-70, 10, "BTN 4 EXITS"}}
call IntensitySprite(100)
textSize = {40, 5}
call TextSizeSprite(textSize)
call TextListSprite(notice)

print "This program defines the Dump subroutine, which can print"
print "the contents of the Vectrex's memory. Instead of running"
print "this program, call Dump, passing in the start and end"
print "addresses."
print "E.g.: call Dump(0xf000, 0xf100)"

repeat
    controls = WaitForFrame(JoystickNone, Controller1, JoystickNone)
until controls[1, 6]

sub Dump(start, end)
    ' Set the refresh rate high. We're not drawing anything, so we can crank up the
    ' rate. To dump the Vectrex's memory, we need to send a command to the Vectrex.
    ' That happens in the WaitForFrame function. By setting the refresh rate high,
    ' WaitForFrame will finish faster and we can dump memory faster.
    call SetFrameRate(150)

    dim peekdata[2]
    while start < end
        ' Send a message to the Vectrex to peek at memory
        call Peek(start, min(16, end - start), peekdata)
        call WaitForFrame(JoystickNone, ControllerNone, JoystickNone)
        ' Wait for the array to be filled with the dumped memory
        while peekdata[1] = 0
        endwhile
        
        ' Print the results
        line = Hex(start / 0x1000) + Hex(start / 0x100 mod 16) + Hex(start / 0x10 mod 16) + hex(start mod 16) + ": "
        data = peekdata[2]
        for i = 1 to ubound(data)
            line = line + Hex(data[i] / 16) + Hex(data[i] mod 16) + " "
        next i
        print line
        start = start + 16
    endwhile
endsub

' Convert an 8 bit number to two hex digits
function Hex(i)
    if i < 10 then
        return chr(i + 48)
    else
        return chr(i - 10 + 65)
    endif
endfunction
